import { Component, OnInit } from '@angular/core';

import { BasketService } from 'src/app/services/basket.service';

@Component({
  selector: 'app-list',
  templateUrl: './list.component.html',
  styleUrls: ['./list.component.css']
})
export class ListComponent implements OnInit {
  needs?: any;
  checkoutNeeds?: number[];

  constructor(private basketService: BasketService) { }

  ngOnInit() {
    this.basketService.getBasketNeeds().subscribe(needs => this.needs = needs);
    this.checkoutNeeds = [];
  }

  removeFromBasket(needID: number) {
    this.basketService.removeNeedFromBasket(Number(needID));
    this.ngOnInit();
  }

  addToCheckout(needID: number) {
    this.checkoutNeeds?.push(needID);
  }

  checkout() {
    this.basketService.checkout(this.checkoutNeeds!);
    this.ngOnInit();
  }
}
