import { Component, OnInit } from '@angular/core';
import { first } from 'rxjs/operators';

import { NeedsService } from 'src/app/services';
import { BasketService } from 'src/app/services/basket.service';

@Component({
  selector: 'app-list',
  templateUrl: './list.component.html',
  styleUrls: ['./list.component.css'],
})
export class ListComponent implements OnInit {
  needs?: any[];

  constructor(private needService: NeedsService, private basketService: BasketService) { }

  ngOnInit() {
    this.needService.getAll().pipe(first()).subscribe(needs => this.needs = needs);
  }

  addToBasket(id: string) {
    this.basketService.addNeedToBasket(Number(id));
  }

  isInBasket(id: string) {
    let need = this.basketService.getNeedFromBasket(Number(id));
    return need != null;
  }
}
